/*
  *** GBA Headers ***
 Franois PESSAUX June 2004
 This header is freeware. It was build from various other free information.
 I thank all people how contributed directly or indirectly to this header.

 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/


#ifndef __GBA_INTERRUPT_H
#define __GBA_INTERRUPT_H

#include <gba.h>

#define INTERRUPT_VBLANK 1
#define INTERRUPT_HBLANK (1<<1)
#define INTERRUPT_VCOUNT (1<<2)
#define INTERRUPT_TIMER0 (1<<3)
#define INTERRUPT_TIMER1 (1<<4)
#define INTERRUPT_TIMER2 (1<<5)
#define INTERRUPT_TIMER3 (1<<6)
#define INTERRUPT_SERIAL (1<<7)
#define INTERRUPT_DMA0 (1<<8)
#define INTERRUPT_DMA1 (1<<9)
#define INTERRUPT_DMA2 (1<<10)
#define INTERRUPT_DMA3 (1<<11)
#define INTERRUPT_KEY (1<<12)
#define INTERRUPT_CART (1<<13)

#define INTERRUPT_VECTOR_VBLANK_INDEX 0
#define INTERRUPT_VECTOR_HBLANK_INDEX 1
#define INTERRUPT_VECTOR_VCOUNT_INDEX 2
#define INTERRUPT_VECTOR_TM0_INDEX 3
#define INTERRUPT_VECTOR_TM1_INDEX 4
#define INTERRUPT_VECTOR_TM2_INDEX 5
#define INTERRUPT_VECTOR_TM3_INDEX 6
#define INTERRUPT_VECTOR_COM_INDEX 7
#define INTERRUPT_VECTOR_DMA0_INDEX 8
#define INTERRUPT_VECTOR_DMA1_INDEX 9
#define INTERRUPT_VECTOR_DMA2_INDEX 10
#define INTERRUPT_VECTOR_DMA3_INDEX 11
#define INTERRUPT_VECTOR_KEYS_INDEX 12
#define INTERRUPT_VECTOR_CART_INDEX 13

#define SET_INTERRUPT(mask) REG_IE |= (mask)
#define UNSET_INTERRUPT(mask) REG_IE &= (~(mask))
#define MARK_IT_AS_HANDLED(mask) REG_IF |= (mask)
#define ENABLE_MASTER_INTERRUPT REG_IME = 1
#define DISABLE_MASTER_INTERRUPT REG_IME = 0

typedef void (*interrupt_handler)(void) ;
#define SET_INTERRUPT_HANDLER(fct) *(interrupt_handler*)(0x03fffffc) = fct

#endif
