/*
  *** GBA Headers ***
 Franois PESSAUX June 2004
 This header is freeware. It was build from various other free information.
 I thank all people how contributed directly or indirectly to this header.

 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/


#ifndef __GBA_SCREEN_MODE_H
#define __GBA_SCREEN_MODE_H

#include <gba.h>

/* Bits from REG_DISPCNT for display control register. */
#define MODE_0 0x0
#define MODE_1 0x1
#define MODE_2 0x2
#define MODE_3 0x3
#define MODE_4 0x4
#define MODE_5 0x5
#define BACKBUFFER 0x10
#define H_BLANK_OAM 0x20 
#define OBJ_MAP_2D 0x0
#define OBJ_MAP_1D 0x40
#define FORCE_BLANK 0x80
#define BG0_ENABLE 0x100
#define BG1_ENABLE 0x200 
#define BG2_ENABLE 0x400
#define BG3_ENABLE 0x800
#define OBJ_ENABLE 0x1000 
#define WIN1_ENABLE 0x2000 
#define WIN2_ENABLE 0x4000
#define WINOBJ_ENABLE 0x8000

/* For background control registers. */
#define BACKGROUND_PRIORITY_0 0
#define BACKGROUND_PRIORITY_1 BIT00
#define BACKGROUND_PRIORITY_2 BIT01
#define BACKGROUND_PRIORITY_3 (BIT01 | BIT00)
#define BACKGROUND_CHAR_BASE_BLOCK_0 0
#define BACKGROUND_CHAR_BASE_BLOCK_1 BIT02
#define BACKGROUND_CHAR_BASE_BLOCK_2 BIT03
#define BACKGROUND_CHAR_BASE_BLOCK_3 (BIT03 | BIT02)
#define BACKGROUND_MOSAIC_DISABLED 0
#define BACKGROUND_MOSAIC_ENABLED BIT06
#define BACKGROUND_COLOR_16 0
#define BACKGROUND_COLOR_256 BIT07
#define BACKGROUND_SCREEN_BASE_BLOCK_0 (0)
#define BACKGROUND_SCREEN_BASE_BLOCK_1 (1<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_2 (2<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_3 (3<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_4 (4<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_5 (5<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_6 (6<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_7 (7<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_8 (8<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_9 (9<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_10 (10<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_11 (11<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_12 (12<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_13 (13<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_14 (14<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_15 (15<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_16 (16<<8)

#define BACKGROUND_SCREEN_BASE_BLOCK_24 (24<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_25 (25<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_26 (26<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_27 (27<<8)
#define BACKGROUND_SCREEN_BASE_BLOCK_28 (28<<8)

#define BACKGROUND_SCREEN_OVER_TRANSPARENT 0
#define BACKGROUND_SCREEN_OVER_TILED BIT13

#define TEXT_BACKGROUND_256x256 0
#define TEXT_BACKGROUND_512x256 BIT14
#define TEXT_BACKGROUND_256x512 BIT15
#define TEXT_BACKGROUND_512x512 (BIT15 | BIT14)
#define ROT_SCAL_BACKGROUND_128x128 0
#define ROT_SCAL_BACKGROUND_256x256 BIT14
#define ROT_SCAL_BACKGROUND_512x512 BIT15
#define ROT_SCAL_BACKGROUND_1024x1024 (BIT15 | BIT14)


#define set_background0(value) REG_BG0CNT = (value)
#define set_background1(value) REG_BG1CNT = (value)
#define set_background2(value) REG_BG2CNT = (value)
#define set_background3(value) REG_BG3CNT = (value)


/* For tiles description data. */
#define CHAR_BASE_BLOCK_0_ADDR ((u16*) 0x6000000)
#define CHAR_BASE_BLOCK_1_ADDR ((u16*) 0x6004000)
#define CHAR_BASE_BLOCK_2_ADDR ((u16*) 0x6008000)
#define CHAR_BASE_BLOCK_3_ADDR ((u16*) 0x600C000)

/* For map description data. */
#define SCREEN_BASE_BLOCK_0_ADDR ((u16*) 0x6000000)
#define SCREEN_BASE_BLOCK_1_ADDR ((u16*) 0x6000800)
#define SCREEN_BASE_BLOCK_2_ADDR ((u16*) 0x6001000)
#define SCREEN_BASE_BLOCK_3_ADDR ((u16*) 0x6001800)
#define SCREEN_BASE_BLOCK_4_ADDR ((u16*) 0x6002000)
#define SCREEN_BASE_BLOCK_5_ADDR ((u16*) 0x6002800)
#define SCREEN_BASE_BLOCK_6_ADDR ((u16*) 0x6003000)
#define SCREEN_BASE_BLOCK_7_ADDR ((u16*) 0x6003800)
#define SCREEN_BASE_BLOCK_8_ADDR ((u16*) 0x6004000)
#define SCREEN_BASE_BLOCK_9_ADDR ((u16*) 0x6004800)
#define SCREEN_BASE_BLOCK_10_ADDR ((u16*) 0x6005000)
#define SCREEN_BASE_BLOCK_11_ADDR ((u16*) 0x6005800)
#define SCREEN_BASE_BLOCK_12_ADDR ((u16*) 0x6006000)
#define SCREEN_BASE_BLOCK_13_ADDR ((u16*) 0x6006800)
#define SCREEN_BASE_BLOCK_14_ADDR ((u16*) 0x6007000)
#define SCREEN_BASE_BLOCK_15_ADDR ((u16*) 0x6007800)
#define SCREEN_BASE_BLOCK_16_ADDR ((u16*) 0x6008000)

#define SCREEN_BASE_BLOCK_24_ADDR ((u16*) 0x600C000)
#define SCREEN_BASE_BLOCK_25_ADDR ((u16*) 0x600C800)
#define SCREEN_BASE_BLOCK_26_ADDR ((u16*) 0x600D000)
#define SCREEN_BASE_BLOCK_27_ADDR ((u16*) 0x600D800)
#define SCREEN_BASE_BLOCK_28_ADDR ((u16*) 0x600E000)

/* For palette description data. */
#define BACKGROUND_PALETTE_ADDR ((u16*) 0x5000000)

/* For modes 3, 4 and 5. */
#define SCREEN_WIDTH_MODE_3 240
#define SCREEN_HEIGHT_MODE_3 160
#define SCREEN_WIDTH_MODE_5 160
#define SCREEN_HEIGHT_MODE_5 128

#define RGB(r,g,b) ((r) | ((g) << 5) | ((b) << 10))

#define plot_mode3(x,y,c) video_memory[(y) * SCREEN_WIDTH_MODE_3 + (x)] = (c)
#define plot_mode5(x,y,c) video_memory[(y) * SCREEN_WIDTH_MODE_5 + (x)] = (c)

/* Setting the screen mode. */
#define set_screen_mode(mode) REG_DISPCNT = (mode)
#define ENABLE_VBLANK_INTERRUPT REG_DISPSTAT |= (BIT03)
#define DISABLE_VBLANK_INTERRUPT REG_DISPSTAT &= (~(BIT03))

#define MOSAIC_BG_HOR(n) (n)
#define MOSAIC_BG_VER(n) ((n) << 4)
#define MOSAIC_OBJ_HOR(n) ((n) << 8)
#define MOSAIC_OBJ_VER(n) ((n) << 12)

#define set_mosaic_mode(bh,bv,oh,ov) REG_MOSAIC = ((bh)|((bv)<<4)|((oh)<<8)|((ov)<<12))

#define FADE_MODE_0 0
#define FADE_MODE_1 (BIT06)
#define FADE_MODE_2 (BIT07)
#define FADE_MODE_3 (BIT07 | BIT06)
#define FADE_SOURCE_BG0 BIT00
#define FADE_SOURCE_BG1 BIT01
#define FADE_SOURCE_BG2 BIT02
#define FADE_SOURCE_BG3 BIT03
#define FADE_TARGET_BG0 BIT08
#define FADE_TARGET_BG1 BIT09
#define FADE_TARGET_BG2 BIT10
#define FADE_TARGET_BG3 BIT11


#define set_blending_mode(mode) REG_BLDMOD = (mode)
#endif

