#include <gba.h>
#include <screen_mode.h>
#include "load_gfx_data.h"
#include "key_control.h"
#include "ending_gfx.h"


void show_ending ()
{
  u16 old_blending_mode = REG_BLDMOD ;
  short i ;

  set_screen_mode (0) ;
  
  set_background0
    (BACKGROUND_PRIORITY_3 |            /* Priorit la plus faible. */
     BACKGROUND_CHAR_BASE_BLOCK_0 |     /* Tiles */
     BACKGROUND_COLOR_256 |             /* 256 couleurs. */
     BACKGROUND_SCREEN_BASE_BLOCK_24 |   /* Map. */
     TEXT_BACKGROUND_256x256) ;         /* 256 x 256 pixels. */

  /* Chargement des tiles et de la map de l'cran de fin. */
  load_palette_tile_map_256
    (CHAR_BASE_BLOCK_0_ADDR,      /* Tiles dest. */
     SCREEN_BASE_BLOCK_24_ADDR,   /* Map dest. */
     ENDING_PALETTE_SIZE,         /* Taille palette. */
     ending_palette,              /* Palette src. */
     ENDING_NB_TILES,             /* Nb tiles. */
     ending_tiles,                /* Tiles src. */
     ENDING_MAP_WIDTH,            /* Largeur map. */
     ENDING_MAP_HEIGHT,           /* Hauteur map. */
     ending_map) ;                /* Map src. */

  /* Fading ouvrant. */
  REG_COLEY = 15 ;
  set_blending_mode (FADE_MODE_3 | FADE_SOURCE_BG0) ;
  set_screen_mode (MODE_0 | BG0_ENABLE) ;
  for (i = (16 << 4) - 1 ; i > 0 ; i--) {
    while (REG_VCOUNT != 160) ;
    REG_COLEY = (u16) (i >> 4) ;
  }
  set_blending_mode (old_blending_mode) ;

  for (;;) {
    KEY_POOL ;
    if ((KEY_HIT (BUTTON_A)) || (KEY_HIT (BUTTON_B)) ||
	(KEY_HIT (BUTTON_SELECT)) || (KEY_HIT (BUTTON_START))) break ;
  }

  /* Fading fermant. */
  REG_COLEY = 0 ;
  set_blending_mode (FADE_MODE_3 | FADE_SOURCE_BG0) ;
  for (i = 0 ; i < (16 << 4) ; i++) {
    while (REG_VCOUNT != 160) ;
    REG_COLEY = (u16) (i >> 4) ;
  }
  set_screen_mode (0) ;
  set_blending_mode (old_blending_mode) ;
}
