#ifndef __GAME_H__
#define __GAME_H__

typedef enum { false, true} bool ;

#define BOARD_WIDTH 9
#define BOARD_HEIGHT 9

enum mode {
  Mode_Quiet = 0,
  Mode_Standard = 1,
  Mode_Arcade = 2,
  Mode_Chrono_1 = 3,
  Mode_Chrono_5 = 4,
  Mode_Chrono_10 = 5
};

#define KILL_DELAY 5
#define ARCADE_START_KILL_DELAY 60
#define ARCADE_SHAPE_BONUS 1
#define ARCADE_LINES_BONUS 5
#define ARCADE_EFFECT_PERCENT 15
#define MAX_EXPLOSIONS 10
#define MIN_EXPLOSIONS 5


struct game {
  enum mode mode ;
  bool lines_allowed ;
  bool columns_allowed ;
  enum shape board[BOARD_WIDTH][BOARD_HEIGHT] ;
  u8 v_counts[BOARD_HEIGHT] ;
  u8 h_counts[BOARD_WIDTH] ;
  struct handled_shape handled ;
  enum shape next ;
  u32 kill_time ;
  u16 player_x ;
  u16 player_y ;
  u32 score ;
};


struct game* init_game (enum mode, bool, bool) ;
bool try_lay_down_piece (struct game *) ;
bool l_or_r_button_pressed (bool, struct game*) ;
bool move_cursor_down (struct game*) ;
bool move_cursor_up (struct game*) ;
bool move_cursor_left (struct game*) ;
bool move_cursor_right (struct game*) ;
void send_penalty (struct game*) ;
void clamp_player_location (struct game*) ;

#endif
