#include <stdlib.h>
#include <gba.h>
#include <interrupt.h>
#include "shapes.h"
#include "game.h"
#include "ihm.h"
#include "ending.h"
#include "starter.h"
#include "intro.h"
#include "intrs.h"
#include "persistent.h"
#include "scoring.h"



int main ()
{
  struct game *game ;
  enum mode wished_mode ;
  bool wished_lines, wished_columns ;

  init_sound_handler () ;
  srand (REG_VCOUNT) ;
  load_scores () ;
  show_intro () ;

  for (;;) {
    show_starter (&wished_mode, &wished_lines, &wished_columns) ;
    load_game_gfx (false) ;
    game = init_game (wished_mode, wished_lines, wished_columns) ;
    mainloop (game) ;
    show_ending () ;
    check_score (game) ;
    show_highscores (game->mode) ;
  }
}
