#include <stdlib.h>
#include <gba.h>
#include "shapes.h"
#include "game.h"
#include "persistent.h"



struct highscores global_highscores = {
  { 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0 }
};


/* Pour viter de saturer la pile. */
static struct save tmp ;


void save_scores ()
{
  u8 *save_memory = (u8*) 0x0E000000 ;
  u16 i ;

  tmp.magic_tag = MAGICNUMBER ;
  tmp.seed = (unsigned int) (17 + rand ()) ;

  /* Les scores. */
  for (i = 0; i < sizeof (struct highscores); i++)
    ((u8*) &tmp.highscores)[i] = ((u8*) &global_highscores)[i] ;
 
  /* Et enfin on crit rellement dans la SRAM. */
  for (i = 0; i < sizeof (struct save); i++)
    save_memory[i] = ((u8*) &tmp)[i] ;
}



bool load_scores ()
{
  u8 *save_memory = (u8*) 0x0E000000 ;
  u16 i ;
 
  for (i = 0; i < sizeof (struct save); i++)
    ((u8*) &tmp)[i] = save_memory[i] ;

  if (tmp.magic_tag != MAGICNUMBER) return (false) ;

  /* Le seed... */
  srand (tmp.seed + 17) ;

  /* Les scores... */
  for (i = 0; i < sizeof (struct highscores); i++)
    ((u8*) &global_highscores)[i] = ((u8*) &tmp.highscores)[i] ;

  return (true) ;
}

