#ifndef __SHAPE_SPRITE_GFX_H__
#define __SHAPE_SPRITE_GFX_H__

#define SHAPE_SPRITE_PALETTE_SIZE 256
#define SHAPE_SPRITE_NB_TILES 32
#define SHAPE_SPRITE_NB_TILES_PER_SHAPE 4

#define SHAPE_SPRITE_TILES_INDEX 0
#define SHAPE_SPRITE_LOADING_OFFSET 0
#define NB_REGULAR_SPRITES 5

/* Ci dessous, *2 car les sprites en 256 couleurs prennent */
/* 2 tiles physiques pour 1 tile logique. */
#define SHAPE_YING_YANG_INDEX \
   (SHAPE_SPRITE_TILES_INDEX + \
   (SHAPE_SPRITE_NB_TILES_PER_SHAPE * NB_REGULAR_SPRITES * 2))
#define SHAPE_ERASER_INDEX \
   (SHAPE_YING_YANG_INDEX + (SHAPE_SPRITE_NB_TILES_PER_SHAPE * 2))
#define SHAPE_RANDOM_EXPLODE_INDEX \
   (SHAPE_ERASER_INDEX + (SHAPE_SPRITE_NB_TILES_PER_SHAPE * 2))


extern const u16 shape_sprite_palette[SHAPE_SPRITE_PALETTE_SIZE]
  __attribute__ ((section (".rodata"))) ;
extern const u8 shape_sprite_tiles[SHAPE_SPRITE_NB_TILES * 64]
  __attribute__ ((section (".rodata"))) ;

#endif
