#ifndef __SHAPES__H_
#define __SHAPES__H_


/* Formes des pices. */
enum shape {
  Shape_None = 0x00,
  Shape_Square_1x1 = 0x01,
  /* U/D/L/R
      _
     |_|
  */
  Shape_Square_4x4 = 0x02,
  /* U/D/L/R
      __
     |  |
     |__|
  */
  Shape_Long = 0x03,
  /*  U/D  L/R
       _
      | |  ____
      | | |____|
      | |
      |_|
  */
  Shape_Junction = 0x04,
  /*  R       L     U       D
       _       _     _     _____
      | |_   _| |  _| |_  |_   _|
      |  _| |_  | |_____|   |_|
      |_|     |_|
  */
  Shape_Stair_1 = 0x05,
  /*   R/L     U/D
       ___        _
      |_  |_    _| |
        |___|  |  _|
               |_|
  */
  Shape_Stair_2 = 0x06,
   /*    ___    _
       _|  _|  | |_
      |___|    |_  |
                 |_|
   */
  Shape_Corner = 0x07,
  /*  _
     | |_
     |___|
   */
  Shape_Unbreakable = 0x08  /* Pnalit indestructible. Jamais propose.    */
                            /* Arrive toute seule et se place toute seule   */
                            /* si le joueur est trop lent  poser sa pice. */
};
/* On ne compte que le nombre de pices relles. "Shape_None" ne compte pas. */
#define SHAPES_NUMBER 7

/* Orientation de pice. */
enum orientation {
  Orient_Up = 0x0,
  Orient_Right = 0x1,
  Orient_Down = 0x2,
  Orient_Left = 0x3
};

enum effect {
  Effect_None = 0,
  Effect_YingYang = 1,
  Effect_Eraser = 2,
  Effect_Random = 3
};

/* L'effet "Effect_None" ne compte pas. */
#define EFFECTS_NUMBER 3


struct handled_shape {
  enum shape shape ;
  enum orientation orientation ;
  enum effect effect ;
};



/* Chain-codes reprsentant la forme des pices. */
struct deltas {
  short x_delta ;
  short y_delta ;
};

struct chain_code {
  unsigned short length ;
  struct deltas *codes ;
};

#endif
